//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  Green
#property indicator_color4  Red
#property indicator_color5  Green
#property indicator_color6  Red
#property indicator_width5  2
#property indicator_width6  2


//
//
//
//
//

extern int	  WPR_Period      = 50;
extern int	  Overbought      = -20;
extern int	  Oversold	      = -80;
extern int	  BarWidth	      = 1;
extern int    CandleWidth     = 2;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = false;
extern string soundFile       = "alert2.wav";

//
//
//
//
//

double Bar1[];
double Bar2[];
double Candle1[];
double Candle2[];
double upArrow[];
double dnArrow[];
double trend[];
		 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
	IndicatorBuffers(7);
	SetIndexBuffer(0,Bar1);    SetIndexStyle(0,DRAW_HISTOGRAM,0,BarWidth);
	SetIndexBuffer(1,Bar2);		SetIndexStyle(1,DRAW_HISTOGRAM,0,BarWidth);		
	SetIndexBuffer(2,Candle1); SetIndexStyle(2,DRAW_HISTOGRAM,0,CandleWidth);
	SetIndexBuffer(3,Candle2); SetIndexStyle(3,DRAW_HISTOGRAM,0,CandleWidth);
	SetIndexBuffer(4,upArrow); SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,221);
   SetIndexBuffer(5,dnArrow); SetIndexStyle(5,DRAW_ARROW); SetIndexArrow(5,222);
   SetIndexBuffer(6,trend);
	IndicatorShortName("WPR Candles:("+	WPR_Period+")");
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
	int counted_bars=IndicatorCounted();
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
         int limit=MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
	for(int i = limit; i>=0; i--)
	{
		double wpr = iWPR(NULL,0,WPR_Period,i);
		Bar1[i]    = EMPTY_VALUE;
      Bar2[i]    = EMPTY_VALUE;
      Candle1[i] = EMPTY_VALUE;
      Candle2[i] = EMPTY_VALUE;
      upArrow[i] = EMPTY_VALUE;
      dnArrow[i] = EMPTY_VALUE;
	   trend[i] = 0;
	   if(wpr > Overbought) trend[i] = 1;   
		if(wpr < Oversold)	trend[i] =-1;
		if(trend[i] == 1)
		{
		  Bar1[i]    = High[i];	
		  Bar2[i]    = Low[i]; 
		  Candle1[i] = MathMax(Open[i],Close[i]);	
		  Candle2[i] = MathMin(Open[i],Close[i]);  
		  if (trend[i+1]!= 1) upArrow[i] = Low[i] - iATR(NULL,0,20,i)/2.0;
		}
		if(trend[i] ==-1)
      {
		  Bar2[i]    = High[i];	
		  Bar1[i]    = Low[i]; 
		  Candle2[i] = MathMax(Open[i],Close[i]);	
		  Candle1[i] = MathMin(Open[i],Close[i]); 
		  if (trend[i+1]!=-1) dnArrow[i] = High[i] + iATR(NULL,0,20,i)/2.0;
		}
		
	}
   
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("crossed overbought");
      else  doAlert("crossed oversold");       
   }       
return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," WPR candles ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," WPR candles "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}




